import * as React from "react";
export declare type MatchFunc<S> = (value: React.ReactNode, state?: S) => boolean;
export declare type ReplacerFunc<V extends React.ReactNode, S> = (value: V, state?: S) => React.ReactNode;
export declare type StateUpdateFunc<S> = (input: React.ReactNode, state?: S) => S;
declare type ReplacerSharedProps<StateType = any> = {
    replace: ReplacerFunc<any, StateType>;
    updateState?: StateUpdateFunc<StateType>;
    initialState?: StateType;
};
export declare type ReplacerProps<StateType = any> = ReplacerSharedProps<StateType> & ({
    match: MatchFunc<StateType>;
    replace: ReplacerFunc<React.ReactNode, StateType>;
} | {
    matchElement: React.ComponentType | string;
    replace: ReplacerFunc<React.ReactElement, StateType>;
} | {
    matchLiteral: MatchFunc<StateType>;
    replace: ReplacerFunc<React.ReactNode, StateType>;
});
export declare function replaceInTree<S = any>(node: React.ReactNode, args: ReplacerProps<S>): React.ReactNode;
declare function Replacer<StateType = any>(props: React.PropsWithChildren<ReplacerProps<StateType>>): React.ReactElement;
export { Replacer };
